﻿(function () {
    'use strict';

    angular
        .module('mmcore.main.data')
        .service('DataService', DataService);

    DataService.$inject = ['$http', '$q', '$log'];

    function DataService($http, $q, $log) {
        var service = {
            getDataFromWebservice: getDataFromWebservice,
            postDataFromEditorToWS: postDataFromEditorToWS,
            saveDataForSolutionToWS: saveDataForSolutionToWS,
            sendDataToServer: sendDataToServer
        };

        return service;
        var elementId = 0;
        var bitModulId = 0;
        var bitPosition = 0;




        function getDataFromWebservice(type, state, angLocation, stateParams) {

            if (type === "editor") {
                var offline = false;
            }

            if ($('body').hasClass('offline') && (type === "uebit" || type === "ebit")) {

                var directoryData;
                var configAdress = "assets/config.xml";

                return $q(function (resolve, reject) {
                    $http.get(configAdress, { withCredentials: true })
                        .then(function (dataNew) {

                            var xmlDoc = $.parseXML(dataNew.data);
                            var $xml = $(xmlDoc);
                            var appId = $xml.find("appId").text();
                            offline = $xml.find("offline").text();

                            var serverAdress = "assets/json/app" + appId + ".json";

                            $http.get("produkt.xml", { withCredentials: true })
                              .then(function (dataNew) {
                                  var xmlDoc = $.parseXML(dataNew.data);
                                  var $xml = $(xmlDoc);
                                  productNumber = $xml.find("productnumber").text();

                                  $http.get(serverAdress, { withCredentials: true })
                                      .then(function (appData) {
                                          var data = appData.data;
                                          resolve(data);
                                      })
                              });
                        },
                    function (error) {
                        reject(error)
                    });
                });
            } else if ($('body').hasClass('online') && (type === "uebit" || type === "ebit")) {

                var directoryData;
                var configAdress = "assets/config.xml";;

                return $q(function (resolve, reject) {
                    $http.get(configAdress, { withCredentials: true })
                        .then(function (dataNew) {

                            var xmlDoc = $.parseXML(dataNew.data);
                            var $xml = $(xmlDoc);
                            var app = AppControll.getInstance();

                            app.annoServiceModel.serviceKey = btoa ($xml.find("authUser").text() + ":" + $xml.find("authPwd").text());
                            app.annoServiceModel.annoServiceUrl = $xml.find("annoService").text();

                            var appId = $xml.find("appId").text();
                            var serverAdress = "assets/json/app" + appId + ".json";
                            var applicationJsonPath = serverAdress;

                            $http.get("produkt.xml", { withCredentials: true })
                                .then(function (dataNew) {
                                    var xmlDoc = $.parseXML(dataNew.data);
                                    var $xml = $(xmlDoc);
                                    annoconnect_possible = $xml.find("annoconnect_possible").text() === "true";

                                    if (annoconnect_possible) {
                                        var app = AppControll.getInstance();
                                        app.annoServiceModel.loginToken = bridgeUserToken;
                                        app.annoServiceModel.bookshelfId = $xml.find("bookshelf_id").text();
                                        app.annoServiceModel.dienstId = $xml.find("service_id").text();
                                        app.annoServiceModel.dienstPassword = $xml.find("service_key").text();
                                        app.annoServiceModel.version = $xml.find("version").text();
                                        app.annoServiceModel.mandant = $xml.find("mandant_id").text();
                                    }

                                    $http.get(applicationJsonPath, { withCredentials: true })
                                        .then(function (appData) {
                                            var data = appData.data;
                                            resolve(data);
                                        })
                                });
                        },
                    function (error) {
                        reject(error)
                    });
                });


            }
            else if (type === "uebit" || type === "ebit") {

                var directoryData;
                var serverAdress;

                if (isLocal) {
                    switch (serverType) {
                        case "dev":
                            serverAdress = "https://autorensystem-ue2.dev.cloud.kle.tt/pue"

                            break;
                        case "false":
                            serverAdress = "https://autorensystem-ue2.dev.cloud.kle.tt/pue"

                            break;
                        case "stage":
                            serverAdress = "https://autorensystem-ue.stage.cloud.kle.tt/pue"

                            break;
                        case "prod":
                            serverAdress = "https://autorensystem-ue.klett.de/pue"
                            break;
                        case "local":
                            serverAdress = "http://localhost:8080/pue"
                            break;

                        default:
                            serverAdress = "https://autorensystem-ue2.dev.cloud.kle.tt/pue"
                    }

                    if (appType === "sequence") {
                        directoryData = serverAdress + "/restUbit/getSequence/" + id;
                    } else if (appType === "application") {
                        directoryData = serverAdress + "/restUbit/getApplication/" + id;
                    }
                    else if (appType === "ebit") {
                        directoryData = serverAdress + "/restUbit/get/" + id;
                    }
                    else if (appType === "uebit") {
                        directoryData = serverAdress + "/restUbit/get/" + id;
                    }
                    else {
                    }
                } else {

                    if (appType === "sequence") {
                        directoryData = "/pue/restUbit/getSequence/" + id;

                    } else if (appType === "application") {
                        directoryData = "/pue/restUbit/getApplication/" + id;
                    }
                    else if (appType === "ebit") {
                        directoryData = "/pue/restUbit/get/" + id;
                    }
                    else if (appType === "uebit") {
                        directoryData = "/pue/restUbit/get/" + id;

                    }
                }

                if (serverType == "dev") {
                }

                var uebitShowingPreview = false;

                /* getting uebit id in case url is in the form http://...:.../Application/application/index.html#/uebit/9 */
                $log.info("WebserviceUrl: " + directoryData);
                return $q(function (resolve, reject) {
                    var serviceURL = directoryData;
                    $http.get(serviceURL, { withCredentials: true })
                        .then(function (dataNew) {
                            if (appType === "sequence") {
                                var data = {
                                    "menu": {
                                        "type": "LIST",
                                        "chapters": [
                                            {
                                                "children":
                                                   [
                                                       {
                                                           "id": +id,
                                                           "title": "TestMItEbit",
                                                           "chapter": "false",
                                                           "subHeading": "false",
                                                           "module": "false",
                                                           "modus": "UEBUNG",
                                                           "tufModus": "AUS",
                                                           "tipEnabled": "true",
                                                           "timeEnabled": "false",
                                                           "toolsEnabled": "false",
                                                           "selected": "false",
                                                           "children": [

                                                           ],
                                                           "sequenz": []

                                                       }


                                                   ]
                                            }
                                        ]
                                    }
                                }

                                data.menu.chapters[0].children[0].sequenz = dataNew.data;
                            }
                            else if (appType === "uebit" || appType === "ebit") {
                                var data = {
                                    "menu": {
                                        "type": "LIST",
                                        "chapters": [
                                            {
                                                "children":
                                                   [
                                                       {
                                                           "id": "1",
                                                           "title": "TestMItEbit",
                                                           "chapter": "false",
                                                           "subHeading": "false",
                                                           "module": "false",
                                                           "modus": "UEBUNG",
                                                           "tufModus": "AUS",
                                                           "tipEnabled": "true",
                                                           "timeEnabled": "false",
                                                           "toolsEnabled": "false",
                                                           "selected": "false",
                                                           "children": [

                                                           ],
                                                           "sequenz": []

                                                       }


                                                   ]
                                            }
                                        ]
                                    }
                                }

                                data.menu.chapters[0].children[0].sequenz.push(dataNew.data);
                            }
                            else if (appType === "application") {
                                var data = dataNew.data;
                            };

                            /* injecting uebit id for preview */
                            if (uebitShowingPreview) {
                                var jsonData = data.data[0].chapter[0].subChapter[0].slideModul[0].href;
                                jsonData = jsonData.replace("UEBIT_ID", uebitId);
                                data.data[0].chapter[0].subChapter[0].slideModul[0].href = jsonData;

                                var slideTitle = data.data[0].chapter[0].subChapter[0].slideModul[0].title;
                                slideTitle = slideTitle.replace("UEBIT_ID", uebitId);
                                data.data[0].chapter[0].subChapter[0].slideModul[0].title = slideTitle;
                            }
                            resolve(data);

                        }, function (error) {
                            reject(error)
                        });

                });
            }
            else if (type === "editor") {

                $log.info("getRequestToWebserverFromEditor...");
                elementId = angLocation.search().elementId
                bitModulId = angLocation.search().bitModulId;
                bitPosition = angLocation.search().bitPosition;

                var solutionEditor = false;
                if (angLocation.search().solution == "true") {
                    solutionEditor = true;
                }   

                if (solutionEditor) {
                    return $q(function (resolve, reject) {
                        var serviceURL = "/pue/restUbit/getSolutionContent/" + elementId;

                        if (angLocation.$$host.indexOf("localhost") !== -1 || angLocation.$$host.indexOf("pascal") !== -1) {
                            //serviceURL = "/pue/restUbit/getEbitElement/16";
                        }

                        $http.get(serviceURL)
                            .then(function (data) {
                                var testDataString = [];
                                if (data.data.message === "No data found") {
                                } else {
                                    testDataString = data.data;
                                }
                                resolve(testDataString);

                            }, function (error) {
                                $log.error("DataService:  " + error.status);
                                reject(error)
                            });
                    });
                } else {
                    return $q(function (resolve, reject) {
                        var serviceURL = "/pue/restUbit/getEbitElement/" + elementId;

                        if (angLocation.$$host.indexOf("localhost") !== -1 || angLocation.$$host.indexOf("pascal") !== -1) {
                            //serviceURL = "/pue/restUbit/getEbitElement/16";
                        }

                        $http.get(serviceURL)
                            .then(function (data) {
                                var testDataString = [];
                                if (data.data.message === "No data found") {
                                } else {
                                    testDataString = data.data;
                                }
                                //var testDataString = [{ "text": "no text found", "fontSize": 22, "fontFamily": "PoloHint", "fill": "green", "fontStyle": "normal", "id": "textb736bbda-8613-01d8-ffb3-d16b845280d9", "lineHeight": 16, "stroke": null, "type": "text", "x": "90", "y": "90", "transform": "matrix(1,0,0,1,222,-2)" }, { "x": "0", "y": "0", "height": "100", "type": "rect", "fill": "green", "width": "100", "id": "rectd6847b9d-467a-c66e-6aa7-b459f195bda3", "transform": "matrix(0.6771,0.7359,-0.7359,0.6771,582.9437,117.3506)", "opacity": 1 }, { "cx": "0", "cy": "0", "rx": "50", "ry": "50", "type": "ellipse", "id": "ellipse4c445dbb-7d55-324f-5a6d-b6ade5367375", "fill": "blue", "transform": "matrix(1,0,0,1,295,167)", "opacity": 1 }, { "x": "0", "y": "0", "height": "100", "type": "image", "width": "100", "src": "http://lorempixel.com/200/300/", "transform": "matrix(8.516,1.555,-0.2191,1.2001,247.1445,169.1456)", "id": "image83ba9dbd-9973-8ccf-4529-145bb42171c7" }, { "x": "0", "y": "0", "height": "100", "type": "image", "width": "100", "src": "http://lorempixel.com/200/300/", "transform": "matrix(1,0,0,1,1,1)", "id": "image879fc8fa-dcbb-31a4-6932-ed24da6889ed" }, { "cx": "0", "cy": "0", "rx": "50", "ry": "50", "type": "ellipse", "id": "ellipsefb89a09c-f03b-8789-f4f5-648f92d6b79e", "fill": "blue", "transform": "matrix(1,0,0,1,100,100)", "opacity": 1 }];

                                resolve(testDataString);

                            }, function (error) {
                                $log.error("DataService:  " + error.status);
                                reject(error)
                            });
                    });
                }
            }
        }


        function postDataFromEditorToWS(data, location) {
            $log.info("postRequestToWebserverFromEditor...");
            var dataString = JSON.stringify(data);
            var elementId = location.search().elementId;

            if (location.$$host.indexOf("localhost") !== -1) {
                //elementId = 16;
            }

            var solutionEditor = false;
            if (location.search().solution == "true") {
                solutionEditor = true;
            }

            if (solutionEditor) {
                return $q(function (resolve, reject) {
                    $.ajax({
                        type: "POST",
                        url: "/pue/restUbit/putSolutionContent",
                        data: { elementId: elementId, jsonSolutionContent: dataString },
                        success: function (data, textStatus, jqXHR) {
                            resolve(true);
                        },
                        error: function (jqXHR, textStatus, errorThrown) {
                            resolve(errorThrown);

                        }
                    });
                }, function (error) {
                    $log.error("DataService:  " + error.status);
                    reject(error)
                });

            } else {

                return $q(function (resolve, reject) {
                    $.ajax({
                        type: "POST",
                        url: "/pue/restUbit/put",
                        data: { elementId: elementId, jsonData: dataString },
                        success: function (data, textStatus, jqXHR) {
                            resolve(true);
                        },
                        error: function (jqXHR, textStatus, errorThrown) {
                            resolve(errorThrown);

                        }
                    });
                }, function (error) {
                    $log.error("DataService:  " + error.status);

                    reject(error)
                });
            }

        }

        // save data for solution image to the webservice
        function saveDataForSolutionToWS(data, location) {
            $log.info("saveDataForSolutionToWS...");
            var dataString = JSON.stringify(data);
            var elementId = location.search().elementId;

            if (location.$$host.indexOf("localhost") !== -1) {
                //elementId = 16;
            }
            //ToDo: change webservice url!!!
            return $q(function (resolve, reject) { 
                $.ajax({
                    type: "POST",
                    url: "/pue/restUbit/putSolutionContent",
                    data: { elementId: elementId, jsonSolutionContent: dataString },
                    success: function (data, textStatus, jqXHR) {
                        resolve(true);
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        resolve(errorThrown);

                    }
                });
            }, function (error) {
                $log.error("DataService:  " + error.status);
                reject(error)
            });

        }

        function sendDataToServer() {

            var bitId = bitModulId;
            var slidePos = bitPosition;
            var appId = bitId;
            var appType = "ebit";
            var seqId = 1;
            return $q(function (resolve, reject) {
                $http({
                    method: 'GET',
                    url: '/pue/restUbit/picture/' + appType + '/' + appId + '/' + seqId + '/' + bitId + '/' + slidePos + '/solutionImg'
                    //url: 'https://localhost:3000/picture/' + appType + '/' + appId + '/' + seqId + '/' + bitId + '/' + slidePos + '/solutionImg'

                }).then(function successCallback(response) {
                    var dataTest = response.data;
                    $log.info("postImageToServer...");

                    var data = new FormData
                    data.append('name', "test1234");
                    data.append('schulfach', "2");
                    data.append('projectName', "test1234");
                    data.append('assetKey', "test1234");
                    data.append('description', "test1234");
                    data.append('reference', "test1234");
                    data.append('type', "BILD_ITEM");
                    data.append("ebitElementId", elementId);

                    function dataURItoBlob(dataURI) {
                        // convert base64/URLEncoded data component to raw binary data held in a string
                        var byteString;
                        if (dataURI.split(',')[0].indexOf('base64') >= 0)
                            byteString = atob(dataURI.split(',')[1]);
                        else
                            byteString = unescape(dataURI.split(',')[1]);
                        // separate out the mime component
                        var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];

                        // write the bytes of the string to a typed array
                        var ia = new Uint8Array(byteString.length);
                        for (var i = 0; i < byteString.length; i++) {
                            ia[i] = byteString.charCodeAt(i);
                        }
                        return new Blob([ia], { type: mimeString });
                    }




                    if (angular.isDefined(elementId)) {
                        var filename = "LF_" + elementId + "";
                    } else {
                        var filename = "LF_noBitID";
                    }

                    var svgBlob = dataURItoBlob(dataTest);

                    data.append("file", svgBlob, filename);


                    $.ajax({
                        type: "POST",
                        url: "/pue/restUbit/updateSolutionImage",
                        data: data,
                        dataType: 'text',
                        contentType: false,
                        processData: false,
                        success: function (data, textStatus, jqXHR) {
                            resolve(true);
                        },
                        error: function (jqXHR, textStatus, errorThrown) {
                            console.log(errorThrown, textStatus)
                            resolve(errorThrown);
                        }
                    });




                });
            }, function (error) {
                $log.error("DataService:  " + error.status);
                reject(error)
            });
        }
    }
})();