﻿jsPlumb.ready(function () {
    // setup some defaults for jsPlumb.
    var instance = jsPlumb.getInstance({
        //Endpoint: ["Dot", {radius: 2}],
        PaintStyle:{ 
			lineWidth: 2,
			outlineWidth: 2 
		},
		DragOptions: { cursor: "pointer", zIndex: 2000 },
        Endpoint: "Blank",
        HoverPaintStyle: {strokeStyle: "#333", lineWidth: 2 },
        Container: "draw-line"
    });

    window.jsp = instance;

    var windows = jsPlumb.getSelector(".draw-line .item");

    jsPlumb.bind("ready", function() {
        // restore connections from data-connections attribute in each item
			        
        $("#uebit .item").each(function () {
            
            if ($(this).attr("data-connections") && $(this).attr("data-connections").length > 0) {
                var targetIds = $(this).attr("data-connections").split(",");

                var corrects = [];
                
                // storage of connections, which were green (=valid)
                if ($(this).attr("data-correctconnections") && $(this).attr("data-correctconnections").length > 0) {
                    corrects = $(this).attr("data-correctconnections").split(",");
                }

                for (var i = 0; i < targetIds.length; i++) {

                    // check if connection was green/valid
                    var isCorrect = false;
                    for (var q = 0; q < corrects.length; q++) {
                        if (corrects[q] && corrects[q].trim() && corrects[q].trim().length > 0) {
                            
                            if(targetIds[i].trim() == corrects[q].trim()) {
                                isCorrect = true;
                                break;
                            }

                        }
                    }

                    var color = isCorrect ? "green" : "#333";
                    
                    if (targetIds[i] && targetIds[i].trim() && targetIds[i].trim().length > 0) {
                        window.jsp.connect({
                            source: $(this).attr("id"),
                            target: targetIds[i].trim(),
                            dropOptions: { hoverClass: "dragHover" },
                            anchor: ["Left", "Right"],
                            connector: ["Straight", { gap: -10 }],
                            connectorStyle: { strokeStyle: "#333", strokeWidth: 2 },
                            paintStyle: {
                                fillStyle: "#333",
                                strokeStyle: color,
                                lineWidth: 2
                            },
                            endpoint: "Blank",
                            allowLoopback: true,
                            deleteEndpointsOnDetach: false
                        });
                    }
                }

                $(this).attr("data-correctconnections", "");
            }
        });
    });

    // initialise draggable elements.
    // instance.draggable(windows);

    // bind a click listener to each connection; the connection is deleted. you could of course
    // just do this: jsPlumb.bind("click", jsPlumb.detach), but I wanted to make it clear what was
    // happening.
    instance.bind("click", function (c) {

        // detach only if not solution display
        if (!$("#solution-btn").hasClass("active") && !$('#evaluate-btn').hasClass('active')) {
            instance.detach(c);
        }
    });


    instance.bind("connectionDetached", function (info) {

        var sourceId = info.sourceId;
        var targetId = info.targetId;

        var targets = $("#" + sourceId).attr('data-connections');
        if (targets)
        {
            if (targets.indexOf(targetId) > -1)
            {
                //replace the target id (case if it is placed on first position)
                targets = targets.replace(", " + targetId, "");
                //replace the target id (case if it is placed on other position then the first one)
                targets = targets.replace(targetId, "");
                $("#" + sourceId).attr('data-connections', targets);
            }
        }

        var corrects = $("#" + sourceId).attr('data-correctconnections');
        if (corrects) {
            if (corrects.indexOf(targetId) > -1) {
                //replace the target id (case if it is placed on first position)
                corrects = corrects.replace(", " + targetId, "");
                //replace the target id (case if it is placed on other position then the first one)
                corrects = corrects.replace(targetId, "");
                $("#" + sourceId).attr('data-correctconnections', corrects);
            }
        }


    });


    // bind a connection listener. note that the parameter passed to this function contains more than
    // just the new connection - see the documentation for a full list of what is included in 'info'.
    // this listener sets the connection's internal
    // id as the label overlay's text.
    instance.bind("connection", function (info) {
        // info.connection.getOverlay("label").setLabel(info.connection.id);
        var index;
        var itemSource;
        var itemTarget;
        for (index = 0; index < windows.length; ++index) {

            if (!itemSource || !itemTarget)
            {
                if (windows[index].id == info.sourceId)
                {
                    itemSource = windows[index];
                }

                if (windows[index].id == info.targetId)
                {
                    itemTarget = windows[index];
                }
            }
        }

        if (itemSource && itemTarget)
        {
            /*if connection is betwwen the same side, it will be cancelled */
            if ((itemSource.className.indexOf("leftStart") > -1 && itemTarget.className.indexOf("leftEnd") > -1) || (itemSource.className.indexOf("rightStart") > -1 && itemTarget.className.indexOf("rightEnd") > -1) || itemTarget.className.indexOf("disabled") > -1 || itemSource.className.indexOf("disabled") > -1)
            {
                jsPlumb.detach(info.connection);
            }
            else
            {
                var conn = info.connection;
                var sourceId = conn.sourceId;
                var targetId = conn.targetId;
                var dontSaveConnectionInHtml = false;

                /* Save connection target information inside data-connections attributes of the source */
                var targetsOfOppositeDirection = $("#" + targetId).attr('data-connections');
                if (targetsOfOppositeDirection)
                {
                    if (targetsOfOppositeDirection.indexOf(sourceId) > -1) // the line is not already drawn in the opposite sens
                    {
                        dontSaveConnectionInHtml = true;
                    }
                }

                var targetsOfCurrentDirection = $("#" + sourceId).attr('data-connections');
                if (targetsOfCurrentDirection) {
                    if (targetsOfCurrentDirection.indexOf(targetId) > -1) // the line is not already drawn in the current sens
                    {
                        dontSaveConnectionInHtml = true;
                    }
                }

                if (!dontSaveConnectionInHtml)
                {
                    var targets = $("#" + sourceId).attr('data-connections');
                    if (targets)
                    {
                        if (targets.indexOf(targetId) == -1)
                        {
                            if (targets == "")
                            {
                                targets = targetId;
                            }
                            else
                            {
                                targets = targets + ", " + targetId;
                            }
                        
                            $("#" + sourceId).attr('data-connections', targets);
                        }
                    }
                    else
                    {
                        $("#" + sourceId).attr('data-connections', targetId);
                    }
                }
                else
                {
                    jsPlumb.detach(info.connection);
                }
            }
        }

     });


    // suspend drawing and initialise.
    instance.batch(function () {
        instance.makeSource(windows, {
            filter: ".ep",
            anchor: ["Left", "Right"],
            connector: ["Straight", {gap: -10}],
            connectorStyle: { strokeStyle: "#333", strokeWidth: 2 },
            endpoint: "Blank",
            allowLoopback: true,
            // maxConnections: 5,
            maxConnections: 13,
            onMaxConnections: function (info, e) {
                console.log("Maximum connections (" + info.maxConnections + ") reached");
            }
        });

        // initialise all '.ep' elements as connection targets.
        instance.makeTarget(windows, {
            filter: ".ep",
            dropOptions: { hoverClass: "dragHover" },
            anchor: ["Left", "Right"],
            connector: "Straight",
            connectorStyle: { strokeStyle: "#333", strokeWidth: 2 },
            endpoint: "Blank",
            allowLoopback: true
        });

    });

    //jsPlumb.fire("jsPlumbDemoLoaded", instance);

    $(window).resize(function(){
        instance.repaintEverything();
    });

});
