$(document).ready(function() 
{
	$(".media-container-flash").css({ 'display': 'none' });
	
	checkUserMedia();
    
    function checkUserMedia()
    {
        var umAvailable = navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia;
     
        /*
        if (offline) 
        {
            umAvailable = false;
        }
        */
        if (umAvailable) 
        {
            try {
                window.AudioContext = window.AudioContext || window.webkitAudioContext;
                
                navigator.getUserMedia = (navigator.getUserMedia || navigator.webkitGetUserMedia || navigator.mozGetUserMedia || navigator.msGetUserMedia);
                window.URL = window.URL || window.webkitURL;

                audio_context = new AudioContext;
                //console.log('Audio context set up.');
                //console.log('navigator.getUserMedia ' + (navigator.getUserMedia ? 'available.' : 'not present!'));
            } catch (e) {
                //console.log('No web audio support in this browser!');
            }
            
            initRecording();
        }
        else 
        {
            // Show Message
            console.log('No web audio support in this browser!');
            
            $(".voice-recording").css({ 'display': 'none' });
            $("#umUnAvailable").modal('show');
            
            
            /*
            $('#a1_1_po_ex1_download').css({ 'display': 'none' });
            $("#recording_01").css({ "display": "none" });
            $("#playRecordedAudio").css({ "display": "none" });
            $(".media-container-html").css({ 'display': 'none' });
            */   
        }  
    }
    
    
    var audio_context;
    var recorder;
    var isRecording = false;
    var activeButton;
    var ownStream = null;

    function initRecording() 
    {
        function showSpinner() 
        {
            activeButton.addClass('loading disabled');
            activeButton.find('i').addClass('icon-spin');
        }

        function hideSpinner() 
        {
            activeButton.removeClass('loading disabled');
            activeButton.find('i').removeClass('icon-spin');
        }

        function startRecording() 
        {
            //curGUID = pc.recorder.start();
            //console.log(curGUID);

            //recorder && recorder.record();
            //var audioButton = activeButton.parent().find('.audio');
            //var downloadButton = activeButton.parent().find('.download');

            //if (audioButton) {
            //    audioButton.css({ 'display': 'none' });
            //}

            //if (downloadButton) {
            //    downloadButton.css({ 'display': 'none' });
            //}

            //button.disabled = true;
            //button.nextElementSibling.disabled = false;
            //__log('Recording...');
        }


        var btnRecord = $('.record');
        btnRecord.click(function() 
        {
            var audioControls = document.getElementById('audioControls');
            audioControls.style.display = "none";

            if (activeButton) 
            {
                activeButton.removeClass('loading disabled');
                activeButton.find('i').removeClass('icon-spin');
            }

            activeButton = $(this);

            if (isRecording) 
            {
                console.log("stopRecording");

                stopRecording(this);
                isRecording = false;
            }
            else 
            {
                console.log("startRecording");

                navigator.getUserMedia({ audio: true }, startUserMedia, function errorCallback() { });
                //console.log('No live audio input: ' + e);
                //     console.log(e);
                //});

                isRecording = true;
            }
        });
    }

    function startUserMedia(stream) 
    {
        //ownStream = new R(stream);
        ownStream = stream;

        var input = audio_context.createMediaStreamSource(stream);
        // console.log('Media stream created.');
        // console.log("input sample rate " + input.context.sampleRate);

        //input.connect(audio_context.destination);
        // console.log('Input connected to audio context destination.');

        recorder = new Recorder(input);
        // console.log('Recorder initialised.');

        startRecording();
    }

    function startRecording(button) 
    {
        recorder && recorder.record();
        
        var audioButton = $("#playRecordedAudio");
        var downloadButton = activeButton.parent().find('.download');

        if (audioButton) 
        {
            audioButton.css({ 'display': 'none' });
        }

        if (downloadButton) 
        {
            downloadButton.css({ 'display': 'none' });
        }

        activeButton.addClass('active');
    }

    function stopRecording(button) 
    {
        ownStream.stop();
        isRecording = false;

        recorder && recorder.stop();
        createDownloadLink();

        recorder.clear();
        activeButton.removeClass('active');
    }

    function createDownloadLink() 
    {
        recorder && recorder.exportWAV(function(blob) 
        {
            var url = URL.createObjectURL(blob);
            var audioButton = $("#playRecordedAudio");

            if (audioButton) 
            {
                if (!isMobile.any) 
                {
                    audioButton.attr('src', url);
                    audioButton.css({ 'display': 'inline-block' });
                }
                else if (isMobile.android.device && !!window.chrome == false) 
                {
                    audioButton.attr('src', url);
                    audioButton.css({ 'display': 'inline-block' });
                }
            }
            
            var downloadButton = activeButton.parent().find('.download');
            if (downloadButton) 
            {
                downloadButton.attr('href', url);
                downloadButton.attr('download', 'sprachaufnahme.wav');
                downloadButton.css({ 'display': 'inline-block' });
            }
        });
    }

    /**
    * initAudioPlayer
    * @param
    */
    function initAudioPlayer() 
    {
        var audioControls = document.getElementById('audioControls');
        audioControls.style.display = "block";

        $("#audioPlayer").jPlayer({
            supplied: "mp3, wav",
            wmode: "window",
            useStateClassSkin: true,
            cssSelectorAncestor: "#audioControls",
            autoBlur: false,
            smoothPlayBar: true,
            globalVolume: true,
            keyEnabled: true,
            remainingDuration: true,
            toggleDuration: true,
            consoleAlerts: true
        });

        $('.close-btn').click(function() 
        {
            var audioPlayer = $('#audioPlayer');
            audioPlayer.jPlayer("stop");
            var audioControls = document.getElementById('audioControls');
            audioControls.style.display = "none";
        });
    }
});